//+------------------------------------------------------------------+
//|                                                    Awesome-3.mq4 |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 DarkOrange
#property indicator_width1 2
#property indicator_color2 LimeGreen 
#property indicator_width2 2
#property indicator_color3 Gray
#property indicator_width3 1
#property indicator_color4  DimGray
#property indicator_width4 1
#property indicator_color5 Magenta
#property indicator_width5 1
#property indicator_color6 DimGray
#property indicator_width6 1
#property indicator_style6 2
#property indicator_color7 DimGray
#property indicator_width7 1
#property indicator_style7 2
extern bool =true;
extern int Up = 10;
extern int Dn = 5;
extern int HistoWidth = 2;
extern bool AO = false;
extern bool ShowSignalLine = false;
extern bool MTF = false;
extern bool ShowSignal=false;
extern int  = 9000;
extern bool DrawZPO=false;
extern int MinMaxSearch=6;
extern int PipsFilter=2;
extern int FixedSpread=3;
extern color ColorUp= Magenta; // White;
extern color ColorDn= Magenta;
extern int Arrow=159;
extern bool ShowLevels=true;
extern double =0.2;
extern double  = 2;
extern int  = 6;
extern color ColorArrUp = Blue;
extern color ColorArrDn = Red;
extern int ArrWidth = 1;
extern color LevelColor = DimGray;
double    ExtBuffer0[],  ExtBuffer1[], ExtBuffer2[], ExtBuffer5[], lhBuffer[], LevUp[], LevDn[], , Down, Up;
int key, TF, nArrow, Win, Signal, Fast, Slow, Mode_MA, Price;
string ShortName;
//+------------------------------------------------------------------+
int init()  {
   if(Digits>=4)  =;  else =*100;
   if(Period()==1) =/;
   if(Period()==15) =+/;
   if(Period()>15) =0;
   if(!AO)  {  Fast = 12;  Slow = 26;  Signal=9;  Mode_MA = 1;  Price   = 0;  }
   if(AO)   {  Fast = 5;   Slow = 34;  Signal=5;  Mode_MA = 0;  Price = 4;    TF=Period();  }
   if(MTF && AO)  {
     switch(Period())  {
       case 1:  Fast = 25;  Slow = 170;  TF = 5;   break;
       case 5:  Fast = 15;  Slow = 102;  TF = 15;  break;
       case 15: Fast = 20;  Slow = 136;  TF = 30;  break;
       case 30: Fast = 10;  Slow =  68;  TF = 60;  break;
       case 60: Fast = 20;  Slow = 136;  TF = 240; break;
       default: Fast = 25;  Slow = 170;  TF = 5;   break;
   } }
   SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,HistoWidth);   SetIndexDrawBegin(0,34);   SetIndexBuffer(0,ExtBuffer1);   SetIndexLabel(0,"Dn");
   SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,HistoWidth);   SetIndexDrawBegin(1,34);   SetIndexBuffer(1,ExtBuffer2);   SetIndexLabel(1,"Up");
   SetIndexStyle(2,DRAW_NONE);                    SetIndexDrawBegin(2,34);   SetIndexBuffer(2,ExtBuffer0);   SetIndexLabel(2,"AO");
   if(ShowSignalLine) {  SetIndexStyle(3,DRAW_LINE);         SetIndexDrawBegin(3,34);   SetIndexBuffer(3,ExtBuffer5);   SetIndexLabel(3,"Sig");  }
   SetIndexStyle(4,DRAW_ARROW);                   SetIndexArrow(4,Arrow);      SetIndexBuffer(4,lhBuffer);     SetIndexLabel(4,"LH");
   if(ShowLevels)  {
     SetIndexStyle(5,DRAW_LINE,2);  SetIndexBuffer(5,LevUp);
     SetIndexStyle(6,DRAW_LINE,2);  SetIndexBuffer(6,LevDn);
   }
   IndicatorDigits(Digits+1);
   if(AO)  ShortName="AO("+TF+")";   else    ShortName="MACD";
   IndicatorShortName(ShortName);
   nArrow = -1;
   return(0);
}
//+------------------------------------------------------------------+
int deinit()  {
   int cObj = ObjectsTotal();
   for(int i = cObj; i > 0; i--)   { 
     string strObj = ObjectName(i - 1);
     if (StringFind(strObj, "zPPOhl_") != -1)    ObjectDelete(strObj);
   }
   ObjectDelete("upl");  ObjectDelete("dnl");
   for( int y=; y>=0; y--)  {  ObjectDelete("Downer"+y);  ObjectDelete("Uper"+y);  }
   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int start()  {
   int    limit,  counted_bars=IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   if(limit>)  limit=;
   int Spread = MarketInfo(Symbol(), MODE_SPREAD);
   for(int i=limit; i>=0; i--)  {  ExtBuffer0[i]=(iMA(NULL,0,Fast,0,Mode_MA,Price,i)-iMA(NULL,0,Slow,0,Mode_MA,Price,i))*1000;  LevUp[i]=;  LevDn[i]=-;  }
   for(    i=limit; i>=0; i--)  ExtBuffer5[i]=iMAOnArray(ExtBuffer0,0,Signal,0,Mode_MA,i);
   
   for(i=limit-1; i>=0; i--)   {
       if(ExtBuffer0[i]>ExtBuffer0[i+1])   {     ExtBuffer2[i]=ExtBuffer0[i];     ExtBuffer1[i]=0.0;  }
       else                                {     ExtBuffer1[i]=ExtBuffer0[i];     ExtBuffer2[i]=0.0;  }
   }

//---- find lows & highs
   for (i=1; i<; i++)   {
       int iPrice;
       double dPrice;
       /* process only if no processed already! */
       if (lhBuffer[i + 2] != lhBuffer[0])
           continue;
       
       if (ExtBuffer0[i+2] > ExtBuffer0[i+1] &&
           ExtBuffer0[i+2] > ExtBuffer0[i+0] &&
           ExtBuffer0[i+2] >= ExtBuffer0[i+3] &&
           ExtBuffer0[i+2] >= ExtBuffer0[i+4] &&
           ExtBuffer0[i+2] > ExtBuffer5[i+2] &&
           ExtBuffer0[i+2] >= )
       {
           /* high */
           nArrow++;
           lhBuffer[i + 2] = ExtBuffer0[i + 2] + 0.0001;
           if(lhBuffer[i + 2]>)  {
             iPrice = ArrayMaximum(High, MinMaxSearch + 1, i + 1);
             dPrice = High[iPrice] + (PipsFilter * Point);
             if (FixedSpread > 0)   dPrice += (FixedSpread * Point);
             else  dPrice += (Spread * Point);
             dPrice = NormalizeDouble(dPrice, Digits);
             if(DrawZPO) DrawDotAtPrice(Time[iPrice], dPrice, "zPPOhl_" + DoubleToStr(nArrow, 0) + "_" + DoubleToStr(dPrice, Digits),  ColorUp, Arrow);
           }
       }
       else
       if (ExtBuffer0[i + 2] < ExtBuffer0[i + 1] &&
           ExtBuffer0[i + 2] < ExtBuffer0[i + 0] &&
           ExtBuffer0[i + 2] <= ExtBuffer0[i + 3] &&
           ExtBuffer0[i + 2] <= ExtBuffer0[i + 4] &&
           ExtBuffer0[i + 2] < ExtBuffer5[i + 2] &&
           ExtBuffer0[i + 2] <= -)
       {
           /* low */
           nArrow++;
           lhBuffer[i + 2] = ExtBuffer0[i + 2] - 0.0001;
           if(lhBuffer[i + 2]<-)  {
             iPrice = ArrayMinimum(Low, MinMaxSearch + 1, i + 1);
             dPrice = Low[iPrice] - (PipsFilter * Point);
             dPrice = NormalizeDouble(dPrice, Digits);
             if(DrawZPO)  DrawDotAtPrice(Time[iPrice],  dPrice,  "zPPOhl_" + DoubleToStr(nArrow, 0) + "_" + DoubleToStr(dPrice, Digits),  ColorDn, Arrow);
           }
       }
   }
   
   if(key!=Time[0])  {
     if(ShowSignal)  if((ExtBuffer0[1]>0 && ExtBuffer0[2]<0) || (ExtBuffer0[1]<0 && ExtBuffer0[2]>0)) Alert(Symbol(),"   ",Period(),"   -2  0 !!!" );
//   if(SigPlus>0.0)    if(SigPlus<=ExtBuffer0[0] && SigPlus>=ExtBuffer0[1])    Alert(Symbol(),"   ",Period(),"       "+DoubleToStr(SigPlus,2));
//   if(SigMinus<0.0)   if(SigMinus>=ExtBuffer0[0] && SigMinus<=ExtBuffer0[1])  Alert(Symbol(),"   ",Period(),"       "+DoubleToStr(SigMinus,2));
     if()  {
       for( int y=; y>=0; y--)  {  ObjectDelete("Downer"+y);  ObjectDelete("Uper"+y);  }
       for(i=-5; i>=0; i--)  {
         if(ExtBuffer0[i+2]<0 && ExtBuffer0[i+1]>0)  {
           int p=i+1;
           while(ExtBuffer0[p]>0)   p++;
           for(int k=p; k>2; k--)  {
             if(ExtBuffer0[k]>0 && ExtBuffer0[k]>ExtBuffer0[k-1])  {           //                if(ExtBuffer0[k]> && ExtBuffer0[k]>ExtBuffer0[k-1])  {                      
               int m=iHighest(Symbol(),0,MODE_HIGH, , k);
               DrawDotAtPrice(Time[m], High[m]+2*Up*Point, "Uper"+m, ColorArrUp, 200);
               break;
         } } }
         if(ExtBuffer0[i+2]>0 && ExtBuffer0[i+1]<0)  {
           p=i+1;
           while(ExtBuffer0[p]<0)   p++;
           for(k=p; k>2; k--)  {
             if(ExtBuffer0[k]<0 && ExtBuffer0[k]<ExtBuffer0[k-1])  {      //             if(ExtBuffer0[k]<- && ExtBuffer0[k]<ExtBuffer0[k-1])  {
               m=iLowest(Symbol(),0,MODE_LOW, , k);
               DrawDotAtPrice(Time[m], Low[m]-Dn*Point, "Downer"+m, ColorArrDn, 202);
               break;
     } } } } }
     key=Time[0];
   }

   Win=WindowFind(ShortName);
   if(ShowLevels && !AO)  {
     ObjectDelete("upl");
     ObjectCreate("upl",OBJ_HLINE,Win,Time[1],);
     ObjectSet   ("upl",OBJPROP_COLOR,LevelColor);
     ObjectSet   ("upl",OBJPROP_STYLE,2);
     ObjectSet   ("upl",OBJPROP_WIDTH,0);
     ObjectSet   ("upl",OBJPROP_BACK,false);

     ObjectDelete("dnl");
     ObjectCreate("dnl",OBJ_HLINE,Win,Time[1],-);
     ObjectSet   ("dnl",OBJPROP_COLOR,LevelColor);
     ObjectSet   ("dnl",OBJPROP_STYLE,2);
     ObjectSet   ("dnl",OBJPROP_WIDTH,0);
     ObjectSet   ("dnl",OBJPROP_BACK,false);
   }
   return(0);
}
//+------------------------------------------------------------------+
bool DrawDotAtPrice(datetime dt, double pr, string strObj, int _color, int Arr)
{
    if (ObjectCreate(strObj, OBJ_ARROW, 0, dt, pr))
    {
        ObjectSet(strObj, OBJPROP_COLOR, _color);
        ObjectSet(strObj, OBJPROP_STYLE, STYLE_SOLID);
        ObjectSet(strObj, OBJPROP_WIDTH, ArrWidth);
        ObjectSet(strObj, OBJPROP_BACK, false);
        ObjectSet(strObj, OBJPROP_ARROWCODE, Arr);
        return(TRUE);
    }
    return(FALSE);
}
//+------------------------------------------------------------------+