//+------------------------------------------------------------------+
//|                                           HighLightBars_mono.mq4 |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 clrSilver
#property indicator_color2 clrSilver
extern bool  = true;
extern bool    TopOnly = true;
extern int     = 5;
extern int           z = 12;
extern color     Color = clrDeepSkyBlue;
extern int       Width = 6;
extern int  = 100;
extern bool  = true;
double ExtMapBuffer1[], ExtMapBuffer2[], zz, z1;
int key;
//+------------------------------------------------------------------+
int init()  {
   SetIndexBuffer(0,ExtMapBuffer1);   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,Width,Color);
   SetIndexBuffer(1,ExtMapBuffer2);   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,Width,Color);
   return(0);
}
//+------------------------------------------------------------------+
int deinit()  {   return(0);  }
//+------------------------------------------------------------------+
int start()  {
   if(key==Time[0]) return(0);
   for(int i=; i>0; i--)  {
     ExtMapBuffer1[i] = 0;
     ExtMapBuffer2[i] = 0;
     if( FindEngulfing(i) )  {       // ingestion
       ExtMapBuffer1[i]  =High[i]+3*Point;
       ExtMapBuffer1[i+1]=High[i]+3*Point;
       ExtMapBuffer2[i]  =Low[i]-3*Point;
       ExtMapBuffer2[i+1]=Low[i]-3*Point;
       if(i==0 && ) Alert(Symbol(),"   ",_Period,"   !");
   } }
   key=Time[0];
   return(0);
}
//+------------------------------------------------------------------+
bool FindEngulfing(int k)  {
  double  high_0, high_1, high_2, high_3, low_0, low_1, low_2, low_3, open_0, open_1, open_2, close_0, close_1, close_2;
  //+------------------------------------------------------------------+
  high_0=High[k-1];
  high_1=High[k];
  high_2=High[k+1];
  high_3=High[k+2];
  low_0  =Low[k-1];
  low_1  =Low[k];
  low_2  =Low[k+1];
  low_3  =Low[k+2];
  open_0 =Open[k-1]; 
  open_1 =Open[k];
  open_2 =Open[k+1];
  close_0=Close[k-1]; 
  close_1=Close[k];
  close_2=Close[k+1];
//+------------------------------------------------------------------+
  if(open_1>close_1 && open_2<close_2)  {
    if()  {
      if(MathMax(open_1,close_1)>=MathMax(open_2,close_2) && MathMin(open_1,close_1)<=MathMin(open_2,close_2))  {
        if(TopOnly)  {
          for(int t=k; t<=k+1; t++)  {
            zz=iCustom(NULL,0,"ZigZag",z,1,1,0,t);
            if(zz>0 && zz>=high_1) return(true);
          }
        }
        else  {
          for(t=k; t<=k+; t++)  {
            zz=iCustom(NULL,0,"ZigZag",z,1,1,0,t);
            if(zz>0 && zz>=high_1) return(true);
    } } } }
    else  {
      if(MathMax(high_1,low_1)>=MathMax(high_2,low_2) && MathMin(high_1,low_1)<=MathMin(high_2,low_2))  {
        if(TopOnly)  {
          for(t=k; t<=k+1; t++)  {
            zz=iCustom(NULL,0,"ZigZag",z,1,1,0,t);
            if(zz>0 && zz>=high_1) return(true);
          }
        }
        else  {
          for (t=k; t<=k+; t++)  {
            zz=iCustom(NULL,0,"ZigZag",z,1,1,0,t);
            if(zz>0 && zz>=high_1) return(true);
  } } } } }
  if(open_1<close_1 && open_2>close_2)  {
    if()  {
      if(MathMax(open_1,close_1)>=MathMax(open_2,close_2) && MathMin(open_1,close_1)<=MathMin(open_2,close_2))  {
        if(TopOnly)  {
          for(t=k; t<=k+1; t++)  {
            zz=iCustom(NULL,0,"ZigZag",z,1,1,0,t);
            if(zz>0 && zz>=low_1) return(true);
          }
        }
        else  {
          for( t=k; t<=k+; t++)  {
            zz=iCustom(NULL,0,"ZigZag",z,1,1,0,t);
            if(zz>0 && zz<=low_1) return(true);
    } } } }
    else  {
      if(MathMax(high_1,low_1)>=MathMax(high_2,low_2) && MathMin(high_1,low_1)<=MathMin(high_2,low_2))  {
        if(TopOnly)  {
          for(t=k; t<=k+1; t++)  {
            zz=iCustom(NULL,0,"ZigZag",z,1,1,0,t);
            if(zz>0 && zz>=low_1) return(true);
          }
        }
        else  {
          for( t=k; t<=k+; t++)  {
            zz=iCustom(NULL,0,"ZigZag",z,1,1,0,t);
            if(zz>0 && zz<=low_1) return(true);
  } } } } }
  return(0);
}
//+------------------------------------------------------------------+
