//+------------------------------------------------------------------+
//|                                                   i@2ST_SW_z.mq4 |
//|                                                             DIFF |
//+------------------------------------------------------------------+
//
#property copyright ""
#property link      ""
#property description "   +ST_mU.mq4"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  DodgerBlue
#property  indicator_color2  Red

#property  indicator_width1  2
#property  indicator_width2  2

//---- indicator parameters
extern string    comm1="ST1:";
input ENUM_TIMEFRAMES timeFrame1 = 0;
extern string sTFs1 = "0 -  TF, 1 -   , 2 -  2 ";
extern int TFs1  = 0;
extern string    comm2="ST2:";
input ENUM_TIMEFRAMES timeFrame2 = 0;
extern string sTFs2 = "0 -  TF, 1 -   , 2 -  2 ";
extern int TFs2  = 1;
extern string    bb3="=============";
extern bool  ShowAlert=true;

//---- indicator buffers
double     stuu[], stdd[];  //
double dst;
double dstp;
datetime tm;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
  IndicatorBuffers(2);
   
   SetIndexBuffer (0,stuu);    SetIndexStyle  (0,DRAW_HISTOGRAM);     SetIndexLabel  (0,"ST 1-2 up-up");
   SetIndexBuffer (1,stdd);    SetIndexStyle  (1,DRAW_HISTOGRAM);     SetIndexLabel  (1,"ST 1-2 down-down");   
   
   IndicatorShortName("i@2ST-z");
   return(0);
  }
//+------------------------------------------------------------------+
//|                          
//+------------------------------------------------------------------+
int start()
  {
   int limit,i;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- --------------
   for(i=limit; i>=1; i--) {
         dst=iCustom(NULL,0,"+ST_mU",timeFrame1,"",TFs1,2,clrDodgerBlue,clrOrange,0,i)-iCustom(NULL,0,"+ST_mU",timeFrame2,"",TFs2,2,clrDodgerBlue,clrOrange,0,i);
         dstp=iCustom(NULL,0,"+ST_mU",timeFrame1,"",TFs1,2,clrDodgerBlue,clrOrange,0,i+1)-iCustom(NULL,0,"+ST_mU",timeFrame2,"",TFs2,2,clrDodgerBlue,clrOrange,0,i+1);
               if (dst>=0) {
                     stuu[i]=1;
                     stdd[i]=0;
               }else {stuu[i]=0; 
                      stdd[i]=1;
                     }
         }
   if (ShowAlert && tm!=Time[0]) {
      if (dst>=0 && dstp<0) Alert(" ST ");else {}
      if (dst<=0 && dstp>0) Alert(" ST ");else {}
      tm=Time[0];
   }            
   return(0);
  }
//+------------------------------------------------------------------+